<div align="center">
<h1 align="center">GenAI Stack </h1>
<h2 align="center">End-to-End Secure & Private Generative AI for All <br>(Your data, your LLM, your Control)</h2>

<a href="https://img.shields.io/badge/Python-3.8%20%7C%203.9%20%7C%203.10-3776AB.svg?style=flat&logo=python&logoColor=white"><img src="https://img.shields.io/badge/Python-3.8%20%7C%203.9%20%7C%203.10-3776AB.svg?style=flat&logo=python&logoColor=white" alt="Python Versions"></a>
<a href="https://discord.gg/4aWV7He2QU"><img src="https://dcbadge.vercel.app/api/server/4aWV7He2QU?style=flat" alt="Discord" /></a>
<a href="https://twitter.com/aiplanethub"><img src="https://img.shields.io/twitter/follow/aiplanethub" alt="Twitter" /></a>
<a href="https://colab.research.google.com/drive/1y6_0MoNWjS9wugv0askP1Jb7zrY_sQT-?usp=sharing"><img src="https://camo.githubusercontent.com/84f0493939e0c4de4e6dbe113251b4bfb5353e57134ffd9fcab6b8714514d4d1/68747470733a2f2f636f6c61622e72657365617263682e676f6f676c652e636f6d2f6173736574732f636f6c61622d62616467652e737667" alt="Colab" /></a>

<p>GenAI Stack is an end-to-end framework for the integration of LLMs into any application. It can be deployed on your own infrastructure, ensuring data privacy. It comes with everything you need for data extraction, vector stores, to reliable model deployment.</p>
<i><a href="https://discord.gg/4aWV7He2QU">👉 Join our Discord community!</a></i>
</div>

## Getting started on Colab

Try out a quick demo of GenAI Stack on Google Colab:

[![Open In Colab](https://colab.research.google.com/assets/colab-badge.svg)](https://colab.research.google.com/drive/1y6_0MoNWjS9wugv0askP1Jb7zrY_sQT-?usp=sharing)

## Quick install

```bash
pip install genai_stack
```

OR

```bash
pip install git+https://github.com/aiplanethub/genai-stack.git
```

## Documentation

The documentation for GenAI Stack can be found at [genaistack.aiplanet.com](https://genaistack.aiplanet.com).

## GenAI Stack Workflow
![GenAI Stack Workflow](https://github.com/aiplanethub/genai-stack/blob/main/assets/workflow.png)


## What is GenAI Stack all about?

GenAI Stack is an end-to-end framework designed to integrate large language models (LLMs) into applications seamlessly. The purpose is to bridge the gap between raw data and actionable insights or responses that applications can utilize, leveraging the power of LLMs.

In short, it orchestrates and streamlines your Generative AI development journey. From the initial steps of ETL (Extract, Transform, Load) data processing to the refined LLM inference stage, GenAI Stack revolutionizes the way you harness the potential of AI, ensuring data privacy, domain-driven, and ensuring factuality without the pitfalls of hallucinations commonly associated with traditional LLMs.

## How can GenAI Stack be helpful?


1. ETL Simplified: GenAI Stack acts as the guiding hand that navigates the complex landscape of data processing. 
2. Hallucination-Free Inference: Bid adieu to the common headaches associated with AI-generated content filled with hallucinations. Our orchestrator’s unique architecture ensures that the LLM inference stage produces outputs rooted in reality and domain expertise. This means you can trust the information generated and confidently utilize it for decision-making, research, and communication purposes.
3. Seamless Integration: Integrating the GenAI Stack into your existing workflow is straight forward whether you’re a seasoned AI developer or just starting out.
4. Customization and Control: Tailor the ETL processes, vector databases, fine-tune inference parameters, and calibrate the system to meet your project’s unique requirements.

## Use Cases:

- AI-Powered Search Engine: Enhance search with context-aware results, moving beyond simple keyword matching.
- Knowledge Base Q&A: Provide direct, dynamic answers from databases, making data access swift and user-friendly.
- Sentiment Analysis: Analyze text sources to gauge public sentiment, offering businesses real-time feedback.
- Customer Support Chatbots: Enhance the operational efficiency of customer support teams with near accurate responses to support queries.
- Information Retrieval on Large Volumes of Documents: Quickly extract specific information or related documents from vast repositories, streamlining data management.

## Contribution guidelines

GenAI Stack thrives in the rapidly evolving landscape of open-source projects. We wholeheartedly welcome contributions in various capacities, be it through innovative features, enhanced infrastructure, or refined documentation.

For a comprehensive guide on the contribution process, please click [here](https://github.com/aiplanethub/genai-stack/blob/main/CONTRIBUTING.md).

## Acknowledgements

* [LangChain](https://github.com/langchain-ai/langchain)
* [LlamaIndex](https://github.com/jerryjliu/llama_index)
* [Weaviate](https://github.com/weaviate/weaviate)
* [ChromaDB](https://github.com/chroma-core/chroma)
  
and the entire OpenSource community.
