"""Initial Migration

Revision ID: 86588cd8155b
Revises: 
Create Date: 2023-09-19 10:41:45.321408

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '86588cd8155b'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.create_table('stack_components',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('type', sa.Enum('ETL', 'EMBEDDING', 'VECTOR_DB', 'MODEL', 'PROMPT_ENGINE', 'RETRIEVER', 'MEMORY', name='stackcomponenttype'), nullable=False),
    sa.Column('config', sa.JSON(), nullable=False),
    sa.Column('meta_data', sa.JSON(), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('modified_at', sa.DateTime(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('stacks',
    sa.Column('id', sa.Integer(), autoincrement=True, nullable=False),
    sa.Column('name', sa.String(length=255), nullable=False),
    sa.Column('description', sa.String(length=255), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('modified_at', sa.DateTime(), nullable=True),
    sa.PrimaryKeyConstraint('id')
    )
    op.create_table('stack_compositions',
    sa.Column('stack_id', sa.Integer(), nullable=False),
    sa.Column('component_id', sa.Integer(), nullable=False),
    sa.Column('created_at', sa.DateTime(), nullable=True),
    sa.Column('modified_at', sa.DateTime(), nullable=True),
    sa.ForeignKeyConstraint(['component_id'], ['stack_components.id'], ondelete='CASCADE'),
    sa.ForeignKeyConstraint(['stack_id'], ['stacks.id'], ondelete='CASCADE'),
    sa.PrimaryKeyConstraint('stack_id', 'component_id')
    )
    # ### end Alembic commands ###


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('stack_compositions')
    op.drop_table('stacks')
    op.drop_table('stack_components')
    # ### end Alembic commands ###
